# 22.04.2022  Volker Pohlers
# Ausgabe der orig. Dateien + RAM-Bereiche (soweit dies mglich ist)
# basiert auf Liste aus packedrom

open IN, "<packedrom.lst";

while (<IN>) {
	if (/^\S.+,.+,/) {

		chomp;
		# MESSAGE "\{bank}, \{pos}h, aadr, \{eaddr}h [\{xeaddr}h], \{saddr}h, typ, "+name+", \{len}, "+fileXname
		my ($bank,$pos,$aadr,$eaddr,$saddr,$typ,$name,$len,$fileXname) = split /\s*,\s*/;
		
		my $filename = $fileXname;
		$filename =~ s/.pck$//i;
		
		my $fsize;
		
		if (-e $filename) { $fsize = -s $filename }
		else { $fsize = -s $fileXname ; $filename = $fileXname }
		
		my $neweadr = sprintf ("0%Xh", hex($aadr) + $fsize);
		$fsize = sprintf ("0%Xh", $fsize);

		#print "$bank, $pos, $aadr, $neweadr, $eaddr, $saddr, '$typ', '$name', $len, $fileXname\n";
		print "$bank, $pos, $aadr, $neweadr, $saddr, '$typ', '$name', $fsize, ${len}h, $filename\n";
	}
	
}

close IN;

